/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.18 from the
 * contents of perl_libzmq3.xs. Do not edit this file, edit perl_libzmq3.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "xs/perl_libzmq3.xs"
#include "perl_libzmq3.h"

STATIC_INLINE
void
P5ZMQ3_set_bang(pTHX_ int err) {
    SV *errsv = get_sv("!", GV_ADD);
    P5ZMQ3_TRACE(" + Set ERRSV ($!) to %d", err);
    sv_setiv(errsv, err);
    sv_setpv(errsv, zmq_strerror(err));
    errno = err;
}

STATIC_INLINE
SV *
P5ZMQ3_zmq_getsockopt_int(P5ZMQ3_Socket *sock, int option) {
    size_t len;
    int    status;
    I32    i32;
    SV     *sv = newSV(0);

    len = sizeof(i32);
    status = zmq_getsockopt(sock->socket, option, &i32, &len);
    if(status == 0) {
        sv_setiv(sv, i32);
    } else {
        SET_BANG;
    }
    return sv;
}

STATIC_INLINE
SV *
P5ZMQ3_zmq_getsockopt_int64(P5ZMQ3_Socket *sock, int option) {
    size_t  len;
    int     status;
    int64_t i64;
    SV      *sv = newSV(0);

    len = sizeof(i64);
    status = zmq_getsockopt(sock->socket, option, &i64, &len);
    if(status == 0) {
        sv_setiv(sv, i64);
    } else {
        SET_BANG;
    }
    return sv;
}

STATIC_INLINE
SV *
P5ZMQ3_zmq_getsockopt_uint64(P5ZMQ3_Socket *sock, int option) {
    size_t len;
    int    status;
    uint64_t u64;
    SV *sv = newSV(0);

    len = sizeof(u64);
    status = zmq_getsockopt(sock->socket, option, &u64, &len);
    if(status == 0) {
        sv_setuv(sv, u64);
    } else {
        SET_BANG;
    }
    return sv;
}

STATIC_INLINE
SV *
P5ZMQ3_zmq_getsockopt_string(P5ZMQ3_Socket *sock, int option, size_t len) {
    int    status;
    char   *string;
    SV     *sv = newSV(0);

    Newxz(string, len, char);
    status = zmq_getsockopt(sock->socket, option, string, &len);
    if(status == 0) {
        sv_setpvn(sv, string, len);
    } else {
        SET_BANG;
    }
    Safefree(string);

    return sv;
}


STATIC_INLINE
int
P5ZMQ3_zmq_setsockopt_int( P5ZMQ3_Socket *sock, int option, int val) {
    int status;
    status = zmq_setsockopt(sock->socket, option, &val, sizeof(int));
    if (status != 0) {
        SET_BANG;
    }
    return status;
}

STATIC_INLINE
int
P5ZMQ3_zmq_setsockopt_int64( P5ZMQ3_Socket *sock, int option, int64_t val) {
    int status;
    status = zmq_setsockopt(sock->socket, option, &val, sizeof(int64_t));
    if (status != 0) {
        SET_BANG;
    }
    return status;
}

STATIC_INLINE
int
P5ZMQ3_zmq_setsockopt_uint64(P5ZMQ3_Socket *sock, int option, uint64_t val) {
    int status;
    status = zmq_setsockopt(sock->socket, option, &val, sizeof(uint64_t));
    if (status != 0) {
        SET_BANG;
    }
    return status;
}
    
STATIC_INLINE
int
P5ZMQ3_zmq_setsockopt_string(P5ZMQ3_Socket *sock, int option, const char *ptr, size_t len) {
    int status;
    status = zmq_setsockopt(sock->socket, option, ptr, len);
    if (status != 0) {
        SET_BANG;
    }
    return status;
}

STATIC_INLINE
int
P5ZMQ3_Message_mg_dup(pTHX_ MAGIC* const mg, CLONE_PARAMS* const param) {
    P5ZMQ3_Message *const src = (P5ZMQ3_Message *) mg->mg_ptr;
    P5ZMQ3_Message *dest;

    P5ZMQ3_TRACE("Message -> dup");
    PERL_UNUSED_VAR( param );
 
    Newxz( dest, 1, P5ZMQ3_Message );
    zmq_msg_init( dest );
    zmq_msg_copy ( dest, src );
    mg->mg_ptr = (char *) dest;
    return 0;
}

STATIC_INLINE
int
P5ZMQ3_Message_mg_free( pTHX_ SV * const sv, MAGIC *const mg ) {
    P5ZMQ3_Message* const msg = (P5ZMQ3_Message *) mg->mg_ptr;

    PERL_UNUSED_VAR(sv);
    P5ZMQ3_TRACE( "START mg_free (Message)" );
    if ( msg != NULL ) {
        P5ZMQ3_TRACE( " + zmq message %p", msg );
        zmq_msg_close( msg );
        Safefree( msg );
    }
    P5ZMQ3_TRACE( "END mg_free (Message)" );
    return 1;
}

STATIC_INLINE
MAGIC*
P5ZMQ3_Message_mg_find(pTHX_ SV* const sv, const MGVTBL* const vtbl){
    MAGIC* mg;

    assert(sv   != NULL);
    assert(vtbl != NULL);

    for(mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic){
        if(mg->mg_virtual == vtbl){
            assert(mg->mg_type == PERL_MAGIC_ext);
            return mg;
        }
    }

    P5ZMQ3_TRACE( "mg_find (Message)" );
    P5ZMQ3_TRACE( " + SV %p", sv )
    croak("ZMQ::LibZMQ3::Message: Invalid ZMQ::LibZMQ3::Message object was passed to mg_find");
    return NULL; /* not reached */
}

STATIC_INLINE
int
P5ZMQ3_Context_invalidate( P5ZMQ3_Context *ctxt ) {
    int rv = -1;
    int close = 1;
    if (ctxt->ctxt == NULL) {
        close = 0;
        P5ZMQ3_TRACE( " + context already seems to be freed");
    }

    if (ctxt->pid != getpid()) {
        close = 0;
        P5ZMQ3_TRACE( " + context was not created in this process");
    }

#ifdef USE_ITHREADS
    if (ctxt->interp != aTHX) {
        close = 0;
        P5ZMQ3_TRACE( " + context was not created in this thread");
    }
#endif
    if (close) {
#ifdef HAS_ZMQ_CTX_DESTROY
        P5ZMQ3_TRACE( " + calling actual zmq_ctx_destroy()");
        rv = zmq_ctx_destroy( ctxt->ctxt );
#else
        P5ZMQ3_TRACE( " + calling actual zmq_term()");
        rv = zmq_term( ctxt->ctxt );
#endif
        if ( rv != 0 ) {
            SET_BANG;
        } else {
#ifdef USE_ITHREADS
            ctxt->interp = NULL;
#endif
            ctxt->ctxt   = NULL;
            ctxt->pid    = 0;
            Safefree(ctxt);
        }
    }
    return rv;
}

STATIC_INLINE
int
P5ZMQ3_Context_mg_free( pTHX_ SV * const sv, MAGIC *const mg ) {
    P5ZMQ3_Context* const ctxt = (P5ZMQ3_Context *) mg->mg_ptr;
    PERL_UNUSED_VAR(sv);

    P5ZMQ3_TRACE("START mg_free (Context)");
    if (ctxt != NULL) {
        P5ZMQ3_Context_invalidate( ctxt );
        mg->mg_ptr = NULL;
    }
    P5ZMQ3_TRACE("END mg_free (Context)");
    return 1;
}

STATIC_INLINE
MAGIC*
P5ZMQ3_Context_mg_find(pTHX_ SV* const sv, const MGVTBL* const vtbl){
    MAGIC* mg;

    assert(sv   != NULL);
    assert(vtbl != NULL);

    for(mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic){
        if(mg->mg_virtual == vtbl){
            assert(mg->mg_type == PERL_MAGIC_ext);
            return mg;
        }
    }

    croak("ZMQ::LibZMQ3::Context: Invalid ZMQ::LibZMQ3::Context object was passed to mg_find");
    return NULL; /* not reached */
}

STATIC_INLINE
int
P5ZMQ3_Context_mg_dup(pTHX_ MAGIC* const mg, CLONE_PARAMS* const param){
    PERL_UNUSED_VAR(mg);
    PERL_UNUSED_VAR(param);
    return 0;
}

STATIC_INLINE
int
P5ZMQ3_Socket_invalidate( P5ZMQ3_Socket *sock )
{
    SV *ctxt_sv = sock->assoc_ctxt;
    int rv;

    P5ZMQ3_TRACE("START socket_invalidate");
    if (sock->pid != getpid()) {
        return 0;
    }

    P5ZMQ3_TRACE(" + zmq socket %p", sock->socket);
    rv = zmq_close( sock->socket );

    if ( SvOK(ctxt_sv) ) {
        P5ZMQ3_TRACE(" + associated context: %p", ctxt_sv);
        SvREFCNT_dec(ctxt_sv);
        sock->assoc_ctxt = NULL;
    }

    Safefree(sock);

    P5ZMQ3_TRACE("END socket_invalidate");
    return rv;
}

STATIC_INLINE
int
P5ZMQ3_Socket_mg_free(pTHX_ SV* const sv, MAGIC* const mg)
{
    P5ZMQ3_Socket* const sock = (P5ZMQ3_Socket *) mg->mg_ptr;
    PERL_UNUSED_VAR(sv);
    P5ZMQ3_TRACE("START mg_free (Socket)");
    if (sock) {
        P5ZMQ3_Socket_invalidate( sock );
        mg->mg_ptr = NULL;
    }
    P5ZMQ3_TRACE("END mg_free (Socket)");
    return 1;
}

STATIC_INLINE
int
P5ZMQ3_Socket_mg_dup(pTHX_ MAGIC* const mg, CLONE_PARAMS* const param){
    P5ZMQ3_TRACE("START mg_dup (Socket)");
#ifdef USE_ITHREADS /* single threaded perl has no "xxx_dup()" APIs */
    mg->mg_ptr = NULL;
    PERL_UNUSED_VAR(param);
#else
    PERL_UNUSED_VAR(mg);
    PERL_UNUSED_VAR(param);
#endif
    P5ZMQ3_TRACE("END mg_dup (Socket)");
    return 0;
}

STATIC_INLINE
MAGIC*
P5ZMQ3_Socket_mg_find(pTHX_ SV* const sv, const MGVTBL* const vtbl){
    MAGIC* mg;

    assert(sv   != NULL);
    assert(vtbl != NULL);

    for(mg = SvMAGIC(sv); mg; mg = mg->mg_moremagic){
        if(mg->mg_virtual == vtbl){
            assert(mg->mg_type == PERL_MAGIC_ext);
            return mg;
        }
    }

    croak("ZMQ::Socket: Invalid ZMQ::Socket object was passed to mg_find");
    return NULL; /* not reached */
}

STATIC_INLINE
void 
PerlZMQ_free_string(void *data, void *hint) {
    PERL_SET_CONTEXT(hint);
    Safefree( (char *) data );
}

#include "mg-xs.inc"

#line 364 "xs/perl_libzmq3.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(pTHX_ const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
            Perl_croak(aTHX_ "Usage: %s::%s(%s)", hvname, gvname, params);
        else
            Perl_croak(aTHX_ "Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
        Perl_croak(aTHX_ "Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#ifdef PERL_IMPLICIT_CONTEXT
#define croak_xs_usage(a,b)    S_croak_xs_usage(aTHX_ a,b)
#else
#define croak_xs_usage        S_croak_xs_usage
#endif

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#line 506 "xs/perl_libzmq3.c"

XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_errno); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_errno)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	int	RETVAL;
	dXSTARG;

	RETVAL = zmq_errno();
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_strerror)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "num");
    {
	int	num = (int)SvIV(ST(0))
;
	const char *	RETVAL;
	dXSTARG;

	RETVAL = zmq_strerror(num);
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_version)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 375 "xs/perl_libzmq3.xs"
        int major, minor, patch;
        I32 gimme;
#line 556 "xs/perl_libzmq3.c"
#line 378 "xs/perl_libzmq3.xs"
        gimme = GIMME_V;
        if (gimme == G_VOID) {
            /* WTF? you don't want a return value?! */
            XSRETURN(0);
        }

        zmq_version(&major, &minor, &patch);
        if (gimme == G_SCALAR) {
            XPUSHs( sv_2mortal( newSVpvf( "%d.%d.%d", major, minor, patch ) ) );
            XSRETURN(1);
        } else {
            mXPUSHi( major );
            mXPUSHi( minor );
            mXPUSHi( patch );
            XSRETURN(3);
        }
#line 574 "xs/perl_libzmq3.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_init)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "nthreads = 5");
    {
	int	nthreads;
#line 399 "xs/perl_libzmq3.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZMQ::LibZMQ3::Context", 20 ));
        void *cxt;
#line 592 "xs/perl_libzmq3.c"
	P5ZMQ3_Context *	RETVAL;

	if (items < 1)
	    nthreads = 5;
	else {
	    nthreads = (int)SvIV(ST(0))
;
	}
#line 402 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_INIT
        P5ZMQ3_TRACE( "START zmq_init" );
        cxt = zmq_init( nthreads );
        if (cxt == NULL) {
            SET_BANG;
            RETVAL = NULL;
        } else {
            Newxz( RETVAL, 1, P5ZMQ3_Context );
            P5ZMQ3_TRACE( " + created context wrapper %p", RETVAL );
            RETVAL->pid    = getpid();
            RETVAL->ctxt   = cxt;
#ifdef USE_ITHREADS
            P5ZMQ3_TRACE( " + threads enabled, aTHX %p", aTHX );
            RETVAL->interp = aTHX;
#endif
            P5ZMQ3_TRACE( " + zmq context %p", RETVAL->ctxt );
        }
        P5ZMQ3_TRACE( "END zmq_init");
#else /* HAS_ZMQ_INIT */
        PERL_UNUSED_VAR(cxt);
        PERL_UNUSED_VAR(nthreads);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_init");
#endif
#line 625 "xs/perl_libzmq3.c"
	ST(0) = sv_newmortal();
    P5ZMQ3_STRUCT2SV(ST(0), RETVAL, ZMQ::LibZMQ3::Context, P5ZMQ3_Context);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_ctx_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_ctx_new)
{
    dVAR; dXSARGS;
    if (items < 0 || items > 1)
       croak_xs_usage(cv,  "nthreads = 5");
    {
	int	nthreads;
#line 432 "xs/perl_libzmq3.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZMQ::LibZMQ3::Context", 20 ));
        void *cxt;
#line 644 "xs/perl_libzmq3.c"
	P5ZMQ3_Context *	RETVAL;

	if (items < 1)
	    nthreads = 5;
	else {
	    nthreads = (int)SvIV(ST(0))
;
	}
#line 435 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_CTX_NEW
        P5ZMQ3_TRACE( "START zmq_ctx_new" );
        cxt = zmq_init( nthreads );
        if (cxt == NULL) {
            SET_BANG;
            RETVAL = NULL;
        } else {
            Newxz( RETVAL, 1, P5ZMQ3_Context );
            P5ZMQ3_TRACE( " + created context wrapper %p", RETVAL );
            RETVAL->pid    = getpid();
            RETVAL->ctxt   = cxt;
#ifdef USE_ITHREADS
            P5ZMQ3_TRACE( " + threads enabled, aTHX %p", aTHX );
            RETVAL->interp = aTHX;
#endif
            P5ZMQ3_TRACE( " + zmq context %p", RETVAL->ctxt );
        }
        P5ZMQ3_TRACE( "END zmq_ctx_new");
#else /* HAS_ZMQ_CTX_NEW */
        PERL_UNUSED_VAR(cxt);
        PERL_UNUSED_VAR(nthreads);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_ctx_new");
#endif
#line 677 "xs/perl_libzmq3.c"
	ST(0) = sv_newmortal();
    P5ZMQ3_STRUCT2SV(ST(0), RETVAL, ZMQ::LibZMQ3::Context, P5ZMQ3_Context);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_term); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_term)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctxt");
    {
	P5ZMQ3_Context *	ctxt;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), ctxt, ZMQ::LibZMQ3::Context, P5ZMQ3_Context, EFAULT)
;
#line 465 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_TERM
        RETVAL = P5ZMQ3_Context_invalidate( ctxt );

        if (RETVAL == 0) {
            /* Cancel the SV's mg attr so to not call zmq_term automatically */
            MAGIC *mg =
                P5ZMQ3_Context_mg_find( aTHX_ SvRV(ST(0)), &P5ZMQ3_Context_vtbl );
            mg->mg_ptr = NULL;
            /* mark the original SV's _closed flag as true */
            {
                SV *svr = SvRV(ST(0));
                if (hv_stores( (HV *) svr, "_closed", &PL_sv_yes ) == NULL) {
                    croak("PANIC: Failed to store closed flag on blessed reference");
                }
            }
        }
#else /* HAS_ZMQ_TERM */
        PERL_UNUSED_VAR(ctxt);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_term");
#endif
#line 719 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_ctx_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_ctx_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "ctxt");
    {
	P5ZMQ3_Context *	ctxt;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), ctxt, ZMQ::LibZMQ3::Context, P5ZMQ3_Context, EFAULT)
;
#line 492 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_CTX_DESTROY
        RETVAL = P5ZMQ3_Context_invalidate( ctxt );

        if (RETVAL == 0) {
            /* Cancel the SV's mg attr so to not call zmq_ctx_destroy automatically */
            MAGIC *mg =
                P5ZMQ3_Context_mg_find( aTHX_ SvRV(ST(0)), &P5ZMQ3_Context_vtbl );
            mg->mg_ptr = NULL;
            /* mark the original SV's _closed flag as true */
            {
                SV *svr = SvRV(ST(0));
                if (hv_stores( (HV *) svr, "_closed", &PL_sv_yes ) == NULL) {
                    croak("PANIC: Failed to store closed flag on blessed reference");
                }
            }
        }
#else /* HAS_ZMQ_CTX_DESTROY */
        PERL_UNUSED_VAR(ctxt);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_ctx_destroy");
#endif
#line 760 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_ctx_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_ctx_get)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ctxt, option_name");
    {
	P5ZMQ3_Context *	ctxt;
	int	option_name = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), ctxt, ZMQ::LibZMQ3::Context, P5ZMQ3_Context, EFAULT)
;
#line 520 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_CTX_GET
        RETVAL = zmq_ctx_get(ctxt->ctxt, option_name);
        if (RETVAL == -1) {
            SET_BANG;
        }
#else
        PERL_UNUSED_VAR(ctxt);
        PERL_UNUSED_VAR(option_name);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_ctx_get");
#endif
#line 793 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_ctx_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_ctx_set)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "ctxt, option_name, option_value");
    {
	P5ZMQ3_Context *	ctxt;
	int	option_name = (int)SvIV(ST(1))
;
	int	option_value = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), ctxt, ZMQ::LibZMQ3::Context, P5ZMQ3_Context, EFAULT)
;
#line 539 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_CTX_SET
        RETVAL = zmq_ctx_set(ctxt->ctxt, option_name, option_value);
        if (RETVAL == -1) {
            SET_BANG;
        }
#else
        PERL_UNUSED_VAR(ctxt);
        PERL_UNUSED_VAR(option_name);
        PERL_UNUSED_VAR(option_value);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_ctx_set");
#endif
#line 829 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_init)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
#line 556 "xs/perl_libzmq3.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZMQ::LibZMQ3::Message", 20 ));
        int rc;
#line 846 "xs/perl_libzmq3.c"
	P5ZMQ3_Message *	RETVAL;
#line 559 "xs/perl_libzmq3.xs"
        Newxz( RETVAL, 1, P5ZMQ3_Message );
        rc = zmq_msg_init( RETVAL );
        if ( rc != 0 ) {
            SET_BANG;
            zmq_msg_close( RETVAL );
            RETVAL = NULL;
        }
#line 856 "xs/perl_libzmq3.c"
	ST(0) = sv_newmortal();
    P5ZMQ3_STRUCT2SV(ST(0), RETVAL, ZMQ::LibZMQ3::Message, P5ZMQ3_Message);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_init_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_init_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "size");
    {
	IV	size = (IV)SvIV(ST(0))
;
#line 573 "xs/perl_libzmq3.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZMQ::LibZMQ3::Message", 20 ));
        int rc;
#line 876 "xs/perl_libzmq3.c"
	P5ZMQ3_Message *	RETVAL;
#line 576 "xs/perl_libzmq3.xs"
        Newxz( RETVAL, 1, P5ZMQ3_Message );
        rc = zmq_msg_init_size(RETVAL, size);
        if ( rc != 0 ) {
            SET_BANG;
            zmq_msg_close( RETVAL );
            RETVAL = NULL;
        }
#line 886 "xs/perl_libzmq3.c"
	ST(0) = sv_newmortal();
    P5ZMQ3_STRUCT2SV(ST(0), RETVAL, ZMQ::LibZMQ3::Message, P5ZMQ3_Message);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_init_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_init_data)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "data, size = -1");
    {
	SV *	data = ST(0)
;
	IV	size;
#line 591 "xs/perl_libzmq3.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZMQ::LibZMQ3::Message", 20 ));
        STRLEN x_data_len;
        char *sv_data = SvPV(data, x_data_len);
        char *x_data;
        int rc;
#line 910 "xs/perl_libzmq3.c"
	P5ZMQ3_Message *	RETVAL;

	if (items < 2)
	    size = -1;
	else {
	    size = (IV)SvIV(ST(1))
;
	}
#line 597 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE("START zmq_msg_init_data");
        if (size >= 0) {
            x_data_len = size;
        }
        Newxz( RETVAL, 1, P5ZMQ3_Message );
        Newxz( x_data, x_data_len, char );
        Copy( sv_data, x_data, x_data_len, char );
        rc = zmq_msg_init_data(RETVAL, x_data, x_data_len, PerlZMQ_free_string, Perl_get_context());
        if ( rc != 0 ) {
            SET_BANG;
            zmq_msg_close( RETVAL );
            RETVAL = NULL;
        }
        else {
            P5ZMQ3_TRACE(" + zmq_msg_init_data created message %p", RETVAL);
        }
        P5ZMQ3_TRACE("END zmq_msg_init_data");
#line 937 "xs/perl_libzmq3.c"
	ST(0) = sv_newmortal();
    P5ZMQ3_STRUCT2SV(ST(0), RETVAL, ZMQ::LibZMQ3::Message, P5ZMQ3_Message);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_data); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_data)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "message");
    {
	P5ZMQ3_Message *	message;
	SV *	RETVAL;

    P5ZMQ3_SV2STRUCT(ST(0), message, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;
#line 621 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE( "START zmq_msg_data" );
        P5ZMQ3_TRACE( " + message content '%s'", (char *) zmq_msg_data(message) );
        P5ZMQ3_TRACE( " + message size '%d'", (int) zmq_msg_size(message) );
        RETVAL = newSV(0);
        sv_setpvn( RETVAL, (char *) zmq_msg_data(message), (STRLEN) zmq_msg_size(message) );
        P5ZMQ3_TRACE( "END zmq_msg_data" );
#line 964 "xs/perl_libzmq3.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_size); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_size)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "message");
    {
	P5ZMQ3_Message *	message;
	size_t	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), message, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;
#line 634 "xs/perl_libzmq3.xs"
        RETVAL = zmq_msg_size(message);
#line 987 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "message");
    {
	P5ZMQ3_Message *	message;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), message, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;
#line 642 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE("START zmq_msg_close");
        RETVAL = zmq_msg_close(message);
        Safefree(message);
        if (RETVAL != 0) {
            SET_BANG;
        }

        {
            MAGIC *mg =
                 P5ZMQ3_Message_mg_find( aTHX_ SvRV(ST(0)), &P5ZMQ3_Message_vtbl );
             mg->mg_ptr = NULL;
        }
        /* mark the original SV's _closed flag as true */
        {
            SV *svr = SvRV(ST(0));
            if (hv_stores( (HV *) svr, "_closed", &PL_sv_yes ) == NULL) {
                croak("PANIC: Failed to store closed flag on blessed reference");
            }
        }
        P5ZMQ3_TRACE("END zmq_msg_close");
#line 1028 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_move); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_move)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dest, src");
    {
	P5ZMQ3_Message *	dest;
	P5ZMQ3_Message *	src;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), dest, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;

    P5ZMQ3_SV2STRUCT(ST(1), src, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;
#line 670 "xs/perl_libzmq3.xs"
        RETVAL = zmq_msg_move( dest, src );
        if (RETVAL != 0) {
            SET_BANG;
        }
#line 1057 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_copy)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dest, src");
    {
	P5ZMQ3_Message *	dest;
	P5ZMQ3_Message *	src;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), dest, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;

    P5ZMQ3_SV2STRUCT(ST(1), src, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;
#line 682 "xs/perl_libzmq3.xs"
        RETVAL = zmq_msg_copy( dest, src );
        if (RETVAL != 0) {
            SET_BANG;
        }
#line 1086 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_socket); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_socket)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ctxt, type");
    {
	P5ZMQ3_Context *	ctxt;
	IV	type = (IV)SvIV(ST(1))
;
#line 694 "xs/perl_libzmq3.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZMQ::LibZMQ3::Socket", 19 ));
        void *sock = NULL;
#line 1106 "xs/perl_libzmq3.c"
	P5ZMQ3_Socket *	RETVAL;

    P5ZMQ3_SV2STRUCT(ST(0), ctxt, ZMQ::LibZMQ3::Context, P5ZMQ3_Context, EFAULT)
;
#line 697 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE( "START zmq_socket" );
        sock = zmq_socket( ctxt->ctxt, type );
        if (sock == NULL) {
            RETVAL = NULL;
            SET_BANG;
        } else {
            Newxz( RETVAL, 1, P5ZMQ3_Socket );
            RETVAL->assoc_ctxt = ST(0);
            RETVAL->socket = sock;
            RETVAL->pid = getpid();
            (void) SvREFCNT_inc(RETVAL->assoc_ctxt);
            P5ZMQ3_TRACE( " + created socket %p", RETVAL );
        }
        P5ZMQ3_TRACE( "END zmq_socket" );
#line 1126 "xs/perl_libzmq3.c"
	ST(0) = sv_newmortal();
    P5ZMQ3_STRUCT2SV(ST(0), RETVAL, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_close); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_close)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "socket");
    {
	P5ZMQ3_Socket *	socket;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
#line 718 "xs/perl_libzmq3.xs"
        RETVAL = P5ZMQ3_Socket_invalidate( socket );
        /* Cancel the SV's mg attr so to not call socket_invalidate again
           during Socket_mg_free
        */
        {
            MAGIC *mg =
                 P5ZMQ3_Socket_mg_find( aTHX_ SvRV(ST(0)), &P5ZMQ3_Socket_vtbl );
             mg->mg_ptr = NULL;
        }

        /* mark the original SV's _closed flag as true */
        {
            SV *svr = SvRV(ST(0));
            if (hv_stores( (HV *) svr, "_closed", &PL_sv_yes ) == NULL) {
                croak("PANIC: Failed to store closed flag on blessed reference");
            }
        }
#line 1165 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_connect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_connect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "socket, addr");
    {
	P5ZMQ3_Socket *	socket;
	char *	addr = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
#line 743 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE( "START zmq_connect" );
        P5ZMQ3_TRACE( " + socket %p", socket );
        RETVAL = zmq_connect( socket->socket, addr );
        P5ZMQ3_TRACE(" + zmq_connect returned with rv '%d'", RETVAL);
        if (RETVAL != 0) {
            SET_BANG;
        }
        P5ZMQ3_TRACE( "END zmq_connect" );
#line 1196 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_disconnect); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_disconnect)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "socket, addr");
    {
	P5ZMQ3_Socket *	socket;
	const char *	addr = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
#line 759 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_DISCONNECT
        RETVAL = zmq_disconnect(socket, addr);
        if (RETVAL != 0) {
            SET_BANG;
        }
#else
        PERL_UNUSED_VAR(socket);
        PERL_UNUSED_VAR(addr);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_disconnect");
#endif
#line 1229 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_bind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_bind)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "socket, addr");
    {
	P5ZMQ3_Socket *	socket;
	char *	addr = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
#line 777 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE( "START zmq_bind" );
        P5ZMQ3_TRACE( " + socket %p", socket );
        RETVAL = zmq_bind( socket->socket, addr );
        P5ZMQ3_TRACE(" + zmq_bind returned with rv '%d'", RETVAL);
        if (RETVAL != 0) {
            SET_BANG;
        }
        P5ZMQ3_TRACE( "END zmq_bind" );
#line 1260 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_unbind); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_unbind)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "socket, addr");
    {
	P5ZMQ3_Socket *	socket;
	const char *	addr = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
#line 793 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_UNBIND
        RETVAL = zmq_unbind(socket, addr);
        if (RETVAL == -1) {
            SET_BANG;
        }
#else
        PERL_UNUSED_VAR(socket);
        PERL_UNUSED_VAR(addr);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_unbind");
#endif
#line 1293 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_recv)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "socket, buf_sv, len, flags = 0");
    {
	P5ZMQ3_Socket *	socket;
	SV *	buf_sv = ST(1)
;
	size_t	len = (size_t)SvUV(ST(2))
;
	int	flags;
#line 813 "xs/perl_libzmq3.xs"
        char *buf;
#line 1315 "xs/perl_libzmq3.c"
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}
#line 815 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE( "START zmq_recv" );
        Newxz( buf, len, char );

        RETVAL = zmq_recv( socket->socket, buf, len, flags );
        P5ZMQ3_TRACE(" + zmq_recv returned with rv '%d'", RETVAL);
        if ( RETVAL == -1 ) {
            SET_BANG;
        } else {
            sv_setpvn( buf_sv, buf, len );
        }
        Safefree(buf);
        P5ZMQ3_TRACE( "END zmq_recv" );
#line 1341 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_msg_recv)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "msg, socket, flags = 0");
    {
	P5ZMQ3_Message *	msg;
	P5ZMQ3_Socket *	socket;
	int	flags;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), msg, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;

    P5ZMQ3_SV2STRUCT(ST(1), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 836 "xs/perl_libzmq3.xs"
#ifndef HAS_ZMQ_MSG_RECV
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_msg_recv");
#else
        P5ZMQ3_TRACE( "START zmq_msg_recv" );
        RETVAL = zmq_msg_recv(msg, socket->socket, flags);
        P5ZMQ3_TRACE(" + zmq_msg_recv returned with rv '%d'", RETVAL);
        if (RETVAL == -1) {
            SET_BANG;
            P5ZMQ3_TRACE(" + zmq_msg_recv got bad status");
        }
        P5ZMQ3_TRACE( "END zmq_msg_recv" );
#endif /* HAS_ZMQ_RCVMSG */
#line 1386 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_recvmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_recvmsg)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "socket, flags = 0");
    {
	P5ZMQ3_Socket *	socket;
	int	flags;
#line 856 "xs/perl_libzmq3.xs"
        SV *class_sv = sv_2mortal(newSVpvn( "ZMQ::LibZMQ3::Message", 20 ));
        int rv;
#line 1405 "xs/perl_libzmq3.c"
	P5ZMQ3_Message *	RETVAL;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 859 "xs/perl_libzmq3.xs"
#ifndef HAS_ZMQ_RECVMSG
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_recvmsg");
#else
        P5ZMQ3_TRACE( "START zmq_recvmsg" );
        Newxz(RETVAL, 1, P5ZMQ3_Message);
        rv = zmq_msg_init(RETVAL);
        if (rv != 0) {
            SET_BANG;
            P5ZMQ3_TRACE("zmq_msg_init failed (%d)", rv);
            XSRETURN_EMPTY;
        }
        rv = zmq_recvmsg(socket->socket, RETVAL, flags);
        P5ZMQ3_TRACE(" + zmq_recvmsg with flags %d", flags);
        P5ZMQ3_TRACE(" + zmq_recvmsg returned with rv '%d'", rv);
        if (rv == -1) {
            SET_BANG;
            P5ZMQ3_TRACE(" + zmq_recvmsg got bad status, closing temporary message");
            zmq_msg_close(RETVAL);
            Safefree(RETVAL);
            XSRETURN_EMPTY;
        }
        P5ZMQ3_TRACE( "END zmq_recvmsg" );
#endif /* HAS_ZMQ_RCVMSG */
#line 1441 "xs/perl_libzmq3.c"
	ST(0) = sv_newmortal();
    P5ZMQ3_STRUCT2SV(ST(0), RETVAL, ZMQ::LibZMQ3::Message, P5ZMQ3_Message);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_send)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "socket, message, size = -1, flags = 0");
    {
	P5ZMQ3_Socket *	socket;
	SV *	message = ST(1)
;
	int	size;
	int	flags;
#line 892 "xs/perl_libzmq3.xs"
        char *message_buf;
        STRLEN usize;
#line 1464 "xs/perl_libzmq3.c"
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	if (items < 3)
	    size = -1;
	else {
	    size = (int)SvIV(ST(2))
;
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}
#line 895 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE( "START zmq_send" );
        if (! SvOK(message))
            croak("ZMQ::LibZMQ3::zmq_send(): NULL message passed");

        message_buf = SvPV( message, usize );
        if ( size != -1 && (STRLEN)size < usize )
            usize = (STRLEN)size;

        P5ZMQ3_TRACE( " + buffer '%s' (%zu)", message_buf, usize );
        P5ZMQ3_TRACE( " + flags %d", flags);
        RETVAL = zmq_send( socket->socket, message_buf, usize, flags );
        P5ZMQ3_TRACE( " + zmq_send returned with rv '%d'", RETVAL );
        if ( RETVAL == -1 ) {
            P5ZMQ3_TRACE( " ! zmq_send error %s", zmq_strerror( zmq_errno() ) );
            SET_BANG;
        }
        P5ZMQ3_TRACE( "END zmq_send" );
#line 1502 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3__zmq_msg_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3__zmq_msg_send)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "message, socket, flags = 0");
    {
	P5ZMQ3_Message *	message;
	P5ZMQ3_Socket *	socket;
	int	flags;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), message, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;

    P5ZMQ3_SV2STRUCT(ST(1), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 921 "xs/perl_libzmq3.xs"
#ifndef HAS_ZMQ_MSG_SEND
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_msg_send");
#else
        P5ZMQ3_TRACE( "START zmq_msg_send" );
        RETVAL = zmq_msg_send(message, socket->socket, flags);
        P5ZMQ3_TRACE( " + zmq_msg_send returned with rv '%d'", RETVAL );
        if ( RETVAL == -1 ) {
            P5ZMQ3_TRACE( " ! zmq_msg_send error %s", zmq_strerror( zmq_errno() ) );
            SET_BANG;
        }
        P5ZMQ3_TRACE( "END zmq_msg_send" );
#endif
#line 1547 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3__zmq_sendmsg); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3__zmq_sendmsg)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "socket, message, flags = 0");
    {
	P5ZMQ3_Socket *	socket;
	P5ZMQ3_Message *	message;
	int	flags;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

    P5ZMQ3_SV2STRUCT(ST(1), message, ZMQ::LibZMQ3::Message, P5ZMQ3_Message, EFAULT)
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 942 "xs/perl_libzmq3.xs"
#ifndef HAS_ZMQ_SENDMSG
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_sendmsg");
#else
        P5ZMQ3_TRACE( "START zmq_sendmsg" );
        RETVAL = zmq_sendmsg(socket->socket, message, flags);
        P5ZMQ3_TRACE( " + zmq_sendmsg returned with rv '%d'", RETVAL );
        if ( RETVAL == -1 ) {
            P5ZMQ3_TRACE( " ! zmq_sendmsg error %s", zmq_strerror( zmq_errno() ) );
            SET_BANG;
        }
        P5ZMQ3_TRACE( "END zmq_sendmsg" );
#endif
#line 1592 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_getsockopt_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_getsockopt_int)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sock, option");
    {
	P5ZMQ3_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	SV *	RETVAL;

    P5ZMQ3_SV2STRUCT(ST(0), sock, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	RETVAL = P5ZMQ3_zmq_getsockopt_int(sock, option);
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_getsockopt_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_getsockopt_int64)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sock, option");
    {
	P5ZMQ3_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	SV *	RETVAL;

    P5ZMQ3_SV2STRUCT(ST(0), sock, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	RETVAL = P5ZMQ3_zmq_getsockopt_int64(sock, option);
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_getsockopt_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_getsockopt_uint64)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "sock, option");
    {
	P5ZMQ3_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	SV *	RETVAL;

    P5ZMQ3_SV2STRUCT(ST(0), sock, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	RETVAL = P5ZMQ3_zmq_getsockopt_uint64(sock, option);
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_getsockopt_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_getsockopt_string)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sock, option, len = 1024");
    {
	P5ZMQ3_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	size_t	len;
	SV *	RETVAL;

    P5ZMQ3_SV2STRUCT(ST(0), sock, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	if (items < 3)
	    len = 1024;
	else {
	    len = (size_t)SvUV(ST(2))
;
	}

	RETVAL = P5ZMQ3_zmq_getsockopt_string(sock, option, len);
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_setsockopt_int); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_setsockopt_int)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sock, option, val");
    {
	P5ZMQ3_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	int	val = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), sock, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	RETVAL = P5ZMQ3_zmq_setsockopt_int(sock, option, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_setsockopt_int64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_setsockopt_int64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sock, option, val");
    {
	P5ZMQ3_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	int64_t	val = (int64_t)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), sock, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	RETVAL = P5ZMQ3_zmq_setsockopt_int64(sock, option, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_setsockopt_uint64); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_setsockopt_uint64)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sock, option, val");
    {
	P5ZMQ3_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	uint64_t	val = (uint64_t)SvUV(ST(2))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), sock, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	RETVAL = P5ZMQ3_zmq_setsockopt_uint64(sock, option, val);
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_setsockopt_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_setsockopt_string)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "sock, option, value");
    {
	P5ZMQ3_Socket *	sock;
	int	option = (int)SvIV(ST(1))
;
	SV *	value = ST(2)
;
#line 1002 "xs/perl_libzmq3.xs"
        size_t len;
        const char *string;
#line 1789 "xs/perl_libzmq3.c"
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), sock, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
#line 1005 "xs/perl_libzmq3.xs"
        string = SvPV( value, len );
        RETVAL = P5ZMQ3_zmq_setsockopt_string(sock, option, string, len);
#line 1798 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_poll); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_poll)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "list, timeout = 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	AV *	list;
	long	timeout;
#line 1015 "xs/perl_libzmq3.xs"
        I32 list_len;
        zmq_pollitem_t *pollitems;
        CV **callbacks;
        int i;
        int rv;
        int eventfired;
#line 1823 "xs/perl_libzmq3.c"

	STMT_START {
		SV* const xsub_tmp_sv = ST(0);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVAV){
		    list = (AV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak(aTHX_ "%s: %s is not an ARRAY reference",
				"ZMQ::LibZMQ3::zmq_poll",
				"list");
		}
	} STMT_END
;

	if (items < 2)
	    timeout = 0;
	else {
	    timeout = (long)SvIV(ST(1))
;
	}
#line 1022 "xs/perl_libzmq3.xs"
        P5ZMQ3_TRACE( "START zmq_poll" );

        list_len = av_len( list ) + 1;
        if (list_len <= 0) {
            XSRETURN(0);
        }

        Newxz( pollitems, list_len, zmq_pollitem_t);
        Newxz( callbacks, list_len, CV *);

        /* list should be a list of hashrefs fd, events, and callbacks */
        for (i = 0; i < list_len; i++) {
            SV **svr = av_fetch( list, i, 0 );
            HV  *elm;

            P5ZMQ3_TRACE( " + processing element %d", i );
            if (svr == NULL || ! SvOK(*svr) || ! SvROK(*svr) || SvTYPE(SvRV(*svr)) != SVt_PVHV) {
                Safefree( pollitems );
                Safefree( callbacks );
                croak("Invalid value on index %d", i);
            }
            elm = (HV *) SvRV(*svr);

            callbacks[i] = NULL;
            pollitems[i].revents = 0;
            pollitems[i].events  = 0;
            pollitems[i].fd      = 0;
            pollitems[i].socket  = NULL;

            svr = hv_fetch( elm, "socket", 6, NULL );
            if (svr != NULL) {
                MAGIC *mg;
                if (! SvOK(*svr) || !sv_isobject( *svr) || ! sv_isa(*svr, "ZMQ::LibZMQ3::Socket")) {
                    Safefree( pollitems );
                    Safefree( callbacks );
                    croak("Invalid 'socket' given for index %d", i);
                }
                mg = P5ZMQ3_Socket_mg_find( aTHX_ SvRV(*svr), &P5ZMQ3_Socket_vtbl );
                pollitems[i].socket = ((P5ZMQ3_Socket *) mg->mg_ptr)->socket;
                P5ZMQ3_TRACE( " + via pollitem[%d].socket = %p", i, pollitems[i].socket );
            } else {
                svr = hv_fetch( elm, "fd", 2, NULL );
                if (svr == NULL || ! SvOK(*svr) || SvTYPE(*svr) != SVt_IV) {
                    Safefree( pollitems );
                    Safefree( callbacks );
                    croak("Invalid 'fd' given for index %d", i);
                }
                pollitems[i].fd = SvIV( *svr );
                P5ZMQ3_TRACE( " + via pollitem[%d].fd = %d", i, pollitems[i].fd );
            }

            svr = hv_fetch( elm, "events", 6, NULL );
            if (svr == NULL || ! SvOK(*svr) || SvTYPE(*svr) != SVt_IV) {
                Safefree( pollitems );
                Safefree( callbacks );
                croak("Invalid 'events' given for index %d", i);
            }
            pollitems[i].events = SvIV( *svr );
            P5ZMQ3_TRACE( " + going to poll events %d", pollitems[i].events );

            svr = hv_fetch( elm, "callback", 8, NULL );
            if (svr == NULL || ! SvOK(*svr) || ! SvROK(*svr) || SvTYPE(SvRV(*svr)) != SVt_PVCV) {
                Safefree( pollitems );
                Safefree( callbacks );
                croak("Invalid 'callback' given for index %d", i);
            }
            callbacks[i] = (CV *) SvRV( *svr );
        }

        /* now call zmq_poll */
        rv = zmq_poll( pollitems, list_len, timeout );
        SET_BANG;
        P5ZMQ3_TRACE( " + zmq_poll returned with rv '%d'", RETVAL );

        if (rv != -1 ) {
            for ( i = 0; i < list_len; i++ ) {
                P5ZMQ3_TRACE( " + checking events for %d", i );
                eventfired = 
                    (pollitems[i].revents & pollitems[i].events) ? 1 : 0;
                if (GIMME_V == G_ARRAY) {
                    mXPUSHi(eventfired);
                }

                if (eventfired) {
                    dSP;
                    ENTER;
                    SAVETMPS;
                    PUSHMARK(SP);
                    PUTBACK;

                    call_sv( (SV*)callbacks[i], G_SCALAR );
                    SPAGAIN;

                    PUTBACK;
                    FREETMPS;
                    LEAVE;
                }
            }
        }

        if (GIMME_V == G_SCALAR) {
            mXPUSHi(rv);
        }
        Safefree(pollitems);
        Safefree(callbacks);
        P5ZMQ3_TRACE( "END zmq_poll" );
#line 1952 "xs/perl_libzmq3.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_device)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "device, insocket, outsocket");
    {
	int	device = (int)SvIV(ST(0))
;
	P5ZMQ3_Socket *	insocket;
	P5ZMQ3_Socket *	outsocket;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(1), insocket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

    P5ZMQ3_SV2STRUCT(ST(2), outsocket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
#line 1135 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_DEVICE
        RETVAL = zmq_device( device, insocket->socket, outsocket->socket );
        if (RETVAL != 0) {
            SET_BANG;
        }
#else
        PERL_UNUSED_VAR(device);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_device");
#endif
#line 1988 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_proxy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_proxy)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "frontend, backend, capture = NULL");
    {
	P5ZMQ3_Socket *	frontend;
	P5ZMQ3_Socket *	backend;
	P5ZMQ3_Socket *	capture;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), frontend, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

    P5ZMQ3_SV2STRUCT(ST(1), backend, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;

	if (items < 3)
	    capture = NULL;
	else {
    P5ZMQ3_SV2STRUCT(ST(2), capture, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
	}
#line 1153 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_PROXY
        if (capture) {
          capture = capture->socket;
        }
        RETVAL = zmq_proxy(frontend->socket, backend->socket, capture);
        if (RETVAL != 0) {
            SET_BANG;
        }
#else
        PERL_UNUSED_VAR(frontend);
        PERL_UNUSED_VAR(backend);
        PERL_UNUSED_VAR(capture);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_proxy");
#endif
#line 2035 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_socket_monitor); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_ZMQ__LibZMQ3_zmq_socket_monitor)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "socket, addr, events");
    {
	P5ZMQ3_Socket *	socket;
	char *	addr = (char *)SvPV_nolen(ST(1))
;
	int	events = (int)SvIV(ST(2))
;
	int	RETVAL;
	dXSTARG;

    P5ZMQ3_SV2STRUCT(ST(0), socket, ZMQ::LibZMQ3::Socket, P5ZMQ3_Socket, ENOTSOCK)
;
#line 1176 "xs/perl_libzmq3.xs"
#ifdef HAS_ZMQ_SOCKET_MONITOR
        RETVAL = zmq_socket_monitor(socket, addr, events);
        if (RETVAL != 0) {
            SET_BANG;
        }
#else
        PERL_UNUSED_VAR(socket);
        PERL_UNUSED_VAR(addr);
        PERL_UNUSED_VAR(events);
        P5ZMQ3_FUNCTION_UNAVAILABLE("zmq_socket_monitor");
#endif
#line 2071 "xs/perl_libzmq3.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_ZMQ__LibZMQ3); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_ZMQ__LibZMQ3)
{
    dVAR; dXSARGS;
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#endif
    XS_VERSION_BOOTCHECK;

        newXS("ZMQ::LibZMQ3::zmq_errno", XS_ZMQ__LibZMQ3_zmq_errno, file);
        newXS("ZMQ::LibZMQ3::zmq_strerror", XS_ZMQ__LibZMQ3_zmq_strerror, file);
        newXS("ZMQ::LibZMQ3::zmq_version", XS_ZMQ__LibZMQ3_zmq_version, file);
        newXS("ZMQ::LibZMQ3::zmq_init", XS_ZMQ__LibZMQ3_zmq_init, file);
        newXS("ZMQ::LibZMQ3::zmq_ctx_new", XS_ZMQ__LibZMQ3_zmq_ctx_new, file);
        newXS("ZMQ::LibZMQ3::zmq_term", XS_ZMQ__LibZMQ3_zmq_term, file);
        newXS("ZMQ::LibZMQ3::zmq_ctx_destroy", XS_ZMQ__LibZMQ3_zmq_ctx_destroy, file);
        newXS("ZMQ::LibZMQ3::zmq_ctx_get", XS_ZMQ__LibZMQ3_zmq_ctx_get, file);
        newXS("ZMQ::LibZMQ3::zmq_ctx_set", XS_ZMQ__LibZMQ3_zmq_ctx_set, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_init", XS_ZMQ__LibZMQ3_zmq_msg_init, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_init_size", XS_ZMQ__LibZMQ3_zmq_msg_init_size, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_init_data", XS_ZMQ__LibZMQ3_zmq_msg_init_data, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_data", XS_ZMQ__LibZMQ3_zmq_msg_data, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_size", XS_ZMQ__LibZMQ3_zmq_msg_size, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_close", XS_ZMQ__LibZMQ3_zmq_msg_close, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_move", XS_ZMQ__LibZMQ3_zmq_msg_move, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_copy", XS_ZMQ__LibZMQ3_zmq_msg_copy, file);
        newXS("ZMQ::LibZMQ3::zmq_socket", XS_ZMQ__LibZMQ3_zmq_socket, file);
        newXS("ZMQ::LibZMQ3::zmq_close", XS_ZMQ__LibZMQ3_zmq_close, file);
        newXS("ZMQ::LibZMQ3::zmq_connect", XS_ZMQ__LibZMQ3_zmq_connect, file);
        newXS("ZMQ::LibZMQ3::zmq_disconnect", XS_ZMQ__LibZMQ3_zmq_disconnect, file);
        newXS("ZMQ::LibZMQ3::zmq_bind", XS_ZMQ__LibZMQ3_zmq_bind, file);
        newXS("ZMQ::LibZMQ3::zmq_unbind", XS_ZMQ__LibZMQ3_zmq_unbind, file);
        newXS("ZMQ::LibZMQ3::zmq_recv", XS_ZMQ__LibZMQ3_zmq_recv, file);
        newXS("ZMQ::LibZMQ3::zmq_msg_recv", XS_ZMQ__LibZMQ3_zmq_msg_recv, file);
        newXS("ZMQ::LibZMQ3::zmq_recvmsg", XS_ZMQ__LibZMQ3_zmq_recvmsg, file);
        newXS("ZMQ::LibZMQ3::zmq_send", XS_ZMQ__LibZMQ3_zmq_send, file);
        newXS("ZMQ::LibZMQ3::_zmq_msg_send", XS_ZMQ__LibZMQ3__zmq_msg_send, file);
        newXS("ZMQ::LibZMQ3::_zmq_sendmsg", XS_ZMQ__LibZMQ3__zmq_sendmsg, file);
        newXS("ZMQ::LibZMQ3::zmq_getsockopt_int", XS_ZMQ__LibZMQ3_zmq_getsockopt_int, file);
        newXS("ZMQ::LibZMQ3::zmq_getsockopt_int64", XS_ZMQ__LibZMQ3_zmq_getsockopt_int64, file);
        newXS("ZMQ::LibZMQ3::zmq_getsockopt_uint64", XS_ZMQ__LibZMQ3_zmq_getsockopt_uint64, file);
        newXS("ZMQ::LibZMQ3::zmq_getsockopt_string", XS_ZMQ__LibZMQ3_zmq_getsockopt_string, file);
        newXS("ZMQ::LibZMQ3::zmq_setsockopt_int", XS_ZMQ__LibZMQ3_zmq_setsockopt_int, file);
        newXS("ZMQ::LibZMQ3::zmq_setsockopt_int64", XS_ZMQ__LibZMQ3_zmq_setsockopt_int64, file);
        newXS("ZMQ::LibZMQ3::zmq_setsockopt_uint64", XS_ZMQ__LibZMQ3_zmq_setsockopt_uint64, file);
        newXS("ZMQ::LibZMQ3::zmq_setsockopt_string", XS_ZMQ__LibZMQ3_zmq_setsockopt_string, file);
        newXS("ZMQ::LibZMQ3::zmq_poll", XS_ZMQ__LibZMQ3_zmq_poll, file);
        newXS("ZMQ::LibZMQ3::zmq_device", XS_ZMQ__LibZMQ3_zmq_device, file);
        newXS("ZMQ::LibZMQ3::zmq_proxy", XS_ZMQ__LibZMQ3_zmq_proxy, file);
        newXS("ZMQ::LibZMQ3::zmq_socket_monitor", XS_ZMQ__LibZMQ3_zmq_socket_monitor, file);

    /* Initialisation Section */

#line 359 "xs/perl_libzmq3.xs"
    {
        P5ZMQ3_TRACE( "Booting ZMQ::LibZMQ3" );
#include "constants-xs.inc"
    }

#line 2147 "xs/perl_libzmq3.c"

    /* End of Initialisation Section */

#if (PERL_REVISION == 5 && PERL_VERSION >= 9)
  if (PL_unitcheckav)
       call_list(PL_scopestack_ix, PL_unitcheckav);
#endif
    XSRETURN_YES;
}

